/*
Elem keresse rendezett szmokbl ll NXM-es mtrixban!
Kzben szmlljuk a keressi ciklus vgrehajtsi szmt (a rekurzv hvsok szmt)!
*/

#include <iostream>

using namespace std;

const int MAXNM = 100;
int x[MAXNM][MAXNM];
int n, m;
int cDb; //ciklus vgrehajtsi szma

void beolvasas(int& y) {
	cerr << "A matrix meretei (1<=N,M<=" << MAXNM << "):";
	cin >> n >> m;
	for (int i = 0; i < n; i++) {
		cerr << i + 1 << ". sor " << m << " db eleme:";
		for (int j = 0; j < m; j++) {
			cin >> x[i][j];
		}
	}
	cerr << "Keresett ertek:";
	cin >> y;
}

void kereses(const int& e, const int& u, const int& y, bool& van, int& k, int& l) {
	cDb++;
	if (e > u) {
		van = false;
	} else {
		l = (e + u) / 2;
		if (x[k][l] == y) {
			van = true;
		} else if (x[k][l] < y) {
			kereses(l + 1, u, y, van, k, l);
		} else {
			kereses(e, l - 1, y, van, k, l);
		}
	}
}

void sorKereses(const int& e, const int& u, const int& y, bool& van, int& k, int& l) {
	cDb++;
	if (e > u) {
		van = false;
	} else {
		k = (e + u) / 2;
		if (x[k][0] <= y && y <= x[k][m - 1]) {
			kereses(0, m - 1, y, van, k, l);
		} else if (x[k][m - 1] < y) {
			sorKereses(k + 1, u, y, van, k, l);
		} else {
			sorKereses(e, k - 1, y, van, k, l);
		}
	}
}

void keresesIndit(const int& y, bool& van, int& k, int& l) {
	sorKereses(0, n - 1, y, van, k, l);
}

void kiiras(const int& y, const bool& van, const int& k, const int& l){
	cerr << "A keresett " << y << " elem ";
	if (van) {
		cout << "Megtalalhato a(z) (" << k + 1 << "," << l + 1 << ") elemben" << endl;
	} else {
		cout << "Nem talalhato meg." << endl;
	}
	cout << "Ciklus vegrehajtasi szama: " << cDb << endl;
}

int main() {
	
	int y, k, l;
	bool van;
	
	beolvasas(y);
	cDb = 0;
	
	keresesIndit(y, van, k, l);
	kiiras(y, van, k, l);
	
	return 0;
}