//package sablon;

import java.io.IOException;
import java.lang.Math;
import java.io.PrintStream;

import mester.IO;


public class feladat {

    public feladat() {
    }

    static final int MaxN = 100;

	static long cDb=0;
	
    static class Input {
        int N;
        int[] X;
        int Y;
    }

    static class Output {
        boolean Van;
		int K;
    }

    static Input beolvas(IO io) throws IOException {
        Input input = new Input();
        input.N = io.nextInt();
		input.X=new int[input.N];
		for (int i=0;i<input.N;i++) {
			input.X[i]=io.nextInt();
		}
        input.Y = io.nextInt();
        return input;
    }
	
	static void kiir(IO io, Input input, Output output) throws IOException {
		if (output.Van) {
			io.writeLn("megtalalhato a(z) "+output.K+". helyen.");
		} else {
			io.writeLn("nem talalhato meg.");
		}
		io.writeLn("Ciklus vegrehajtasi szama:"+cDb);
    }

	static void Kereses(Input in,int E,int U,Output out){
		cDb++;
		if (E>U) {
			out.Van=false;
		} else {
			int K=(E+U) / 2;
			if (in.X[K]==in.Y) {
			  out.Van=true;
			  out.K=K+1;
			} else if (in.X[K]<in.Y) {
				Kereses(in,K+1,U,out);
			} else {
			//if in.X[K]>in.Y then
				Kereses(in,E,K-1,out);
			}
		}
	}
	
	static Output KeresesIndit(Input in) {
		Output out=new Output();
		Kereses(in,0,in.N-1,out);
		return out;
	}
	
	static Output megold(Input input) {
		Output output=KeresesIndit(input);
		return output;
	}
   
    public static void main(String[] args) throws Exception {
        IO io = new IO();

        Input input = beolvas(io);

        Output output = megold(input);

        kiir(io, input, output);

        io.close();
    }

}