'''
Logaritmikus keresés

  Feladat: Elem keresése rendezett számokból álló N elemű sorozatban!
           Közben számláljuk a keresési ciklus végrehajtási számát (a rekurzív hívások számát)!
'''
import sys
def Beolvasás():
    sys.stderr.write("Elemek szama >=0: ")
    N=int(input())
    X=[0]
    for i in range(N):
        sys.stderr.write(str(i+1)+". egész szám: ")
        X.append(int(input()))
    sys.stderr.write("A keresett értél:")
    Y=int(input())
    return N,X,Y #N-re nem lenne szükség, X hossza leolvasható a Pythonban

def Keresés(X,E,U,Y,cDb):  # a kimenő értékek függvény visszatérési értékként  
    cDb+=1
    K=(E+U) // 2
    if E>U:   
        Van=False
    else:      
        if X[K]==Y:
            Van=True
        else:
            if X[K]<Y:
                Van,K,cDb=Keresés(X,K+1,U,Y,cDb)
            else:
                if X[K]>Y:
                    Van,K,cDb=Keresés(X,E,K-1,Y,cDb)
   
    return Van,K,cDb
      
  
def Kiirás(Y, Van, K,cDb):
    sys.stderr.write("A keresett "+str(Y)+" elem ") 
    if Van:
      print("Megtalalható a(z) "+str(K)+". helyen.")
    else:
      print("Nem talalható meg.");

    print("Ciklus végrehajtási száma:"+str(cDb)) 


N,X,Y=Beolvasás()
Van,K,cDb=Keresés(X,1,N,Y,0)
Kiirás(Y,Van,K,cDb)
