'''
 Keresés rendezett mátrixban

  Feladat: Elem keresése rendezett számokból álló NXM-es mátrixban!
           Közben számláljuk a keresési ciklus végrehajtási számát (a rekurzív hívások számát)!
'''

import sys
def Beolvasás():
    sys.stderr.write("A mátrix méretei >1")
    X=[0] #a 0. sort feltöltjük, hogy jobban igazodjunk az algoritmus indexeléshez
    (N,M)=list(map(lambda x:int(x),input().split()))
    for i in range(N):
        sys.stderr.write("Kérem az "+str(i+1)+" sor tartalmát: ")               
        sor=list(map(lambda x:int(x),input().split()))
        sor.insert(0,0)  #0. helyet feltöltjük, hogy az indexelés ne változzon az algoritmushoz képest
        X.append(sor)
    sys.stderr.write("A keresett értél:")
    Y=int(input())
    return N,X,Y
                       
def Keresés(XSor,E,U,Y,cDb): #a logaritmikus keresés algoritmusa, a mátrix aktuális sora kerül XSor-ba,
                            #Pythonban a mátrix sorok sora, így egy sor könnyen hozzáférhető

    cDb+=1
    L=(E+U) // 2
    if E>U:   
        Van=False
    else:      
        if XSor[L]==Y:
            Van=True
        else:
            if XSor[L]<Y:
                Van,L,cDb=Keresés(XSor,L+1,U,Y,cDb)
            else:
                if XSor[L]>Y:
                    Van,L,cDb=Keresés(XSor,E,L-1,Y,cDb)
   
    return Van,L,cDb

def SorKeres(X,E,U,Y,cDb): 
    cDb+=1
    L=0 #ha nincs ilyen elem, az L változó nem jön létre enélkül
    K=(E+U) // 2
    if E>U:
        Van=False
    else:
        M=len(X[K])-1
        if X[K][1]<=Y and Y<=X[K][M]:
            Van,L,cDb=Keresés(X[K],1,M,Y,cDb)
        else:
            if X[K][M]<Y:
                Van,K,L,cDb=SorKeres(X,K+1,U,Y,cDb)
            else:
                Van,K,L,cDb=SorKeres(X,E,K-1,Y,cDb)
    return Van,K,L,cDb
                    
def Kiirás(Y, Van, K,L,cDb):
    sys.stderr.write("A keresett "+str(Y)+" elem ") 
    if Van:
      print("Megtalalható a(z) ("+str(K)+","+str(L)+") elemben.")
    else:
      print("Nem talalható meg.");

    print("Ciklus végrehajtási száma:"+str(cDb)) 

N,X,Y=Beolvasás()
Van,K,L,cDb=SorKeres(X,1,N,Y,0)
Kiirás(Y,Van,K,L,cDb)
