/*
Feladat: Elem keresse rendezett szmokbl ll N elem sorozatban!
Kzben szmlljuk a keressi ciklus vgrehajtsi szmt (a rekurzv hvsok szmt)!
*/

#include <iostream>

using namespace std;

const int MAXN = 100;
int cDb; //ciklus vgrehajtsi szma

void beolvasas (int& n, int x[], int& y) {
	cerr << "Elemek szama (0.." << MAXN << "):";
	cin >> n;
	for (int i = 0; i < n; i++) {
		cerr << i + 1 << ". egesz szam: "; 
		cin >> x[i];
	}
	cerr << "Keresett ertek: ";
	cin >> y;
}

void kereses (const int t[], const int& e, const int& u, const int& y, bool& van, int& k) {
	cDb++;
	if (e > u) {
		van = false;
	} else {
		k = (e + u) / 2;
		if (t[k] == y) {
			van = true;
		} else if (t[k] < y) {
			kereses(t, k + 1, u, y, van, k);
		} else {
			kereses(t, e, k - 1, y, van, k);
		}
	}
}

void keresesIndit(const int& n, const int t[], const int& y, bool& van, int& k) {
	kereses(t, 0, n - 1, y, van, k);
}

void kiiras(const int &y, const bool &van, const int &k){
	cerr << "A keresett " << y << " elem ";
	if (van) {
		cout << "megtalalhato a(z) " << k + 1 << ". helyen" << endl;
	} else {
		cout << "nem talalhato meg." << endl;
	}
	cout << "Ciklus vegrehajtasi szama: " << cDb << endl;
}

int main() {
	
	int n, t[MAXN], y, k;
	bool van;
	
	beolvasas(n, t, y);
	cDb = 0;
	
	keresesIndit(n, t, y, van, k);
	kiiras(y, van, k);
	
	return 0;
}