//package sablon;

import java.io.IOException;
import java.lang.Math;
import java.io.PrintStream;

import mester.IO;


public class feladat {

    public feladat() {
    }

    static final int MaxNM = 100;

	static long cDb=0;
	
    static class Input {
        int N;
        int M;
        int[][] X;
        int Y;
    }

    static class Output {
        boolean Van;
		int K;
		int L;
    }

    static Input beolvas(IO io) throws IOException {
        Input input = new Input();
        input.N = io.nextInt();
        input.M = io.nextInt();
		input.X=new int[input.N][input.M];
		for (int i=0;i<input.N;i++) {
			for (int j=0;j<input.M;j++) {
				input.X[i][j]=io.nextInt();
			}
		}
        input.Y = io.nextInt();
        return input;
    }
	
	static void kiir(IO io, Input input, Output output) throws IOException {
		if (output.Van) {
			io.writeLn("Megtalalhato a(z) ("+output.K+","+output.L+") elemben.");
		} else {
			io.writeLn("Nem talalhato meg.");
		}
		io.writeLn("Ciklus vegrehajtasi szama:"+cDb);
    }

	static void Kereses(Input in,int E,int U,Output out){
		cDb++;
		if (E>U) {
			out.Van=false;
		} else {
			int L=(E+U) / 2;
			if (in.X[out.K-1][L]==in.Y) {
			  out.Van=true;
			  out.L=L+1;
			} else if (in.X[out.K-1][L]<in.Y) {
				Kereses(in,L+1,U,out);
			} else {
			//if in.X[out.K-1][L]>in.Y then
				Kereses(in,E,L-1,out);
			}
		}
	}

	static void SorKereses(Input in,int E,int U,Output out){
		cDb++;
		if (E>U) {
			out.Van=false;
		} else {
			int K=(E+U) / 2;
			if ((in.X[K][0]<=in.Y) && (in.Y<=in.X[K][in.M-1])) {
				out.K=K+1;
				Kereses(in,0,in.M-1,out);
			} else if (in.X[K][in.M-1]<in.Y) {
				SorKereses(in,K+1,U,out);
			} else {
			//if in.X[K][in.M-1]>in.Y then
				SorKereses(in,E,K-1,out);
			}
		}
	}
	
	static Output KeresesIndit(Input in) {
		Output out=new Output();
		SorKereses(in,0,in.N-1,out);
		return out;
	}
	
	static Output megold(Input input) {
		Output output=KeresesIndit(input);
		return output;
	}
   
    public static void main(String[] args) throws Exception {
        IO io = new IO();

        Input input = beolvas(io);

        Output output = megold(input);

        kiir(io, input, output);

        io.close();
    }

}