Program Logaritmikus_kereses;
(*
  Feladat: Elem keresése rendezett számokból álló N elemű sorozatban!
  *        Közben számláljuk a keresési ciklus végrehajtási számát (a rekurzív hívások számát)!
*)
  Const
    MaxN=100;
  Type
    TElem=Integer;
    TElemek=Array [1..MaxN] of TElem;
  Var
    N:Integer;
    X:TElemek;
    Y:TElem;
    Van: Boolean;
    K:Integer;
    cDb:LongInt;//ciklus végrehajtási száma

  Procedure Beolvasas(Var N:Integer; Var X:TElemek; Var Y:TElem);
    Var
      i:integer;
  Begin
    //A felhasználónak szánt tájékoztató üzenetek az StrErr csatotnára írandók!
    //Például a kérdések:
    Write(StdErr,'Elemek szama (0..',MaxN,'):');
    //A bemenetet nem ellenőrizzük sem szintaktikai, sem szemantikai szempontból.
    Readln(N);//0<=N<=MaxN
    For i:=1 to N do
    Begin
      Write(StdErr,i:3,'. egesz szam:'); 
      Readln(X[i]);
    End;
    Write(StdErr,#10#13'Keresett ertek :'); Readln(Y);
    Write(StdErr,#10#13);
  End;

  Procedure KeresesIndit(Const N:Integer; Const X:TElemek; Const Y:TElem; 
                         Var Van:Boolean; Var K:Integer);
                         
    Procedure Kereses(Const X:TElemek; 
                      Const E,U:Integer;
                      Const Y:TElem; Var Van:Boolean; Var K:Integer);
    Begin
      Inc(cDb);
      If E>U then 
      Begin
        Van:=False
      End
        else
      Begin
        K:=(E+U) Div 2;
        If X[K]=Y then Van:=True
        else if X[K]<Y then Kereses(X,K+1,U,Y,Van,K)
        else {if X[K]>Y then} Kereses(X,E,K-1,Y,Van,K);
      End;
    End;//Kereses

  Begin//KeresesIndit
    Kereses(X,1,N,Y,Van,K);
  End;
  
  Procedure Kiiras(Const Y:TElem; Const Van:Boolean; Const K:Integer);
  Begin
    //A kimenetet kísérő szövegek is az StdErr-re irandók!
    Write(StdErr,'A keresett ',Y,' elem '); 
    If Van then
    Begin
      Writeln('megtalalhato a(z) ',K,'. helyen.');
    End
      else
    Begin
      Writeln('nem talalhato meg.');
    End;
    Writeln('Ciklus vegrehajtasi szama:',cDb); 
  End;
  
Begin
  Beolvasas(N,X,Y);
  cDb:=0;
  KeresesIndit(N,X,Y,Van,K);
  Kiiras(Y,Van,K);
End.
