Program Logaritmikus_kereses;
(*
  Feladat: Elem keresése rendezett számokból álló NXM-es mátrixban!
  *        Közben számláljuk a keresési ciklus végrehajtási számát (a rekurzív hívások számát)!
*)
  Const
    MaxNM=100;
  Type
    TElem=Integer;
    TElemek=Array [1..MaxNM,1..MaxNM] of TElem;
  Var
    N,M:Integer;
    X:TElemek;
    Y:TElem;
    Van: Boolean;
    K,L:Integer;
    cDb:LongInt;//ciklus végrehajtási száma

  Procedure Beolvasas(Var N,M:Integer; Var X:TElemek; Var Y:TElem);
  (*
  * Input:
  * N M
  * 1. sor M db eleme, köztük szóköz
  * ...
  * N. sor M db eleme, köztük szóköz
  *)
    Var
      i,j:integer;
  Begin
    //A felhasználónak szánt tájékoztató üzenetek az StrErr csatotnára írandók!
    //Például a kérdések:
    Write(StdErr,'A mtrix meretei (1<=N,M<=',MaxNM,'):');
    //A bemenetet nem ellenőrizzük sem szintaktikai, sem szemantikai szempontból.
    Readln(N,M);//0<=N,M<=MaxN
    For i:=1 to N do
    Begin
      Writeln(StdErr,i,'. sor ',M,' db eleme:'); 
      For j:=1 to M do
      Begin
        Read(X[i,j]);
      End;
      Readln;
    End;
    Write(StdErr,#10#13'Keresett ertek:'); Readln(Y);
    Write(StdErr,#10#13);
  End;

  Procedure KeresesIndit(Const N,M:Integer; Const X:TElemek; Const Y:TElem; 
                         Var Van:Boolean; Var K,L:Integer);
                         
    Procedure SorKereses(Const X:TElemek; 
                         Const E,U:Integer;
                         Const Y:TElem; Var Van:Boolean; Var K,L:Integer);

      Procedure Kereses(Const X:TElemek; 
                        Const E,U:Integer;
                        Const Y:TElem; Var Van:Boolean; Var K,L:Integer);
      Begin
        //Writeln({$I %LINE%},' N,M,K,L.E,U:',N:4,M:3,K:3,L:3,E:3,U:3);
        Inc(cDb);
        If E>U then 
        Begin
          Van:=False
        End
          else
        Begin
          L:=(E+U) Div 2;
          //Writeln({$I %LINE%},' L,E,U:',L:4,E:3,U:3);
          If X[K,L]=Y then Van:=True
          else if X[K,L]<Y then Kereses(X,L+1,U,Y,Van,K,L)
          else {if X[K,L]>Y then} Kereses(X,E,L-1,Y,Van,K,L);
        End;
      End;

    Begin//SorKereses
      //Writeln({$I %LINE%},' N,M,K,L.E,U:',N:4,M:3,K:3,L:3,E:3,U:3);
      Inc(cDb);
      If E>U then 
      Begin
        Van:=False
      End
        else
      Begin
        K:=(E+U) Div 2;
        //Writeln({$I %LINE%},' K,E,U:',K:4,E:3,U:3);
        If (X[K,1]<=Y) and (Y<=X[K,M]) then Kereses(X,1,M,Y,Van,K,L)
        else if X[K,M]<Y then SorKereses(X,K+1,U,Y,Van,K,L)
        else {if X[K]>Y then} SorKereses(X,E,K-1,Y,Van,K,L);
      End;
    End;//SorKereses

  Begin//KeresesIndit
    SorKereses(X,1,N,Y,Van,K,L);
  End;
  
  Procedure Kiiras(Const Y:TElem; Const Van:Boolean; Const K,L:Integer);
  Begin
    //A kimenetet kísérő szövegek is az StdErr-re irandók!
    Write(StdErr,'A keresett ',Y,' elem '); 
    If Van then
    Begin
      Writeln('Megtalalhato a(z) (',K,',',L,') elemben.');
    End
      else
    Begin
      Writeln('Nem talalhato meg.');
    End;
    Writeln('Ciklus vegrehajtasi szama:',cDb); 
  End;
  
Begin
  Beolvasas(N,M,X,Y);
  cDb:=0;
  KeresesIndit(N,M,X,Y,Van,K,L);
  Kiiras(Y,Van,K,L);
End.
